package cz.upol.zp4jv.lecture02;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.Socket;

/**
 * Implementace klienta, ktery pristupuje k datum
 * nizkouronove pomoci protokolu HTTP
 */
public class HTTPExample {
	
	public static void main(String[] args) throws IOException {
		String host = "www.upol.cz";
		int port = 80;
		String file = "/kontakty/";
		
		try (Socket socket = new Socket(host, port);
		     InputStream inpStream = socket.getInputStream();
			 OutputStream outStream = socket.getOutputStream();
			 BufferedReader rd = new BufferedReader(new InputStreamReader(inpStream));
			 BufferedWriter wr = new BufferedWriter(new OutputStreamWriter(outStream))) {
				
			wr.write("GET " + file + " HTTP/1.0\r\n");
			wr.write("Host: " + host + "\r\n");
			wr.write("\r\n");
			wr.flush();
			
			String line;
			StringBuilder buf = new StringBuilder();
			while ((line = rd.readLine()) != null)
				buf.append(line).append("\n");
			
			System.out.println(buf);
		 }
	}
}
