package cz.upol.zp4jv.lecture02;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.ServerSocket;
import java.net.Socket;

/**
 * Implementace jednoducheho serveru, ktery prijima textove retezce
 * a vraci tyto retezce s tim, ze prevede mala pismena na velka
 */
public class ServerExample {
	
	private static boolean stopServer = false;
	
	public static void main(String[] args) throws IOException {
		
		ServerSocket srvSocket = new ServerSocket(4242);
		
		while (!stopServer) {
			System.out.println("Waiting for a client");
			try (Socket clientSocket = srvSocket.accept();
			     BufferedReader rd = new BufferedReader(new InputStreamReader(clientSocket.getInputStream()));
			     BufferedWriter wr = new BufferedWriter(new OutputStreamWriter(clientSocket.getOutputStream()))) {
				
				processRequests(rd, wr);
			}
		}
		
		System.out.println("So long!");
		srvSocket.close();	
	}
	
	/**
	 * Metoda zajistujici komunikaci s klientem pres dvojici objektu tridy Reader+Writer
	 */
	private static void processRequests(BufferedReader rd, BufferedWriter wr) throws IOException {
		while (true) {
			String line = rd.readLine();
			if (line == null) break;
			
			System.out.println("Request: " + line);
			if (line.equalsIgnoreCase("quit")) break;
			if (line.equalsIgnoreCase("stopServer")) {
				stopServer = true;
				break;
			}
			
			String resp = line.toUpperCase();
			System.out.println("Response: " + resp);
			wr.write(resp);
			wr.write('\n');
			wr.flush();			
		}
	}
}
